// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rmf_door_msgs:msg/DoorState.idl
// generated code does not contain a copyright notice
#include "rmf_door_msgs/msg/detail/door_state__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rmf_door_msgs/msg/detail/door_state__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace builtin_interfaces
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const builtin_interfaces::msg::Time &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  builtin_interfaces::msg::Time &);
size_t get_serialized_size(
  const builtin_interfaces::msg::Time &,
  size_t current_alignment);
size_t
max_serialized_size_Time(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace builtin_interfaces

namespace rmf_door_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rmf_door_msgs::msg::DoorMode &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rmf_door_msgs::msg::DoorMode &);
size_t get_serialized_size(
  const rmf_door_msgs::msg::DoorMode &,
  size_t current_alignment);
size_t
max_serialized_size_DoorMode(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rmf_door_msgs


namespace rmf_door_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rmf_door_msgs
cdr_serialize(
  const rmf_door_msgs::msg::DoorState & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: door_time
  builtin_interfaces::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.door_time,
    cdr);
  // Member: door_name
  cdr << ros_message.door_name;
  // Member: current_mode
  rmf_door_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.current_mode,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rmf_door_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rmf_door_msgs::msg::DoorState & ros_message)
{
  // Member: door_time
  builtin_interfaces::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.door_time);

  // Member: door_name
  cdr >> ros_message.door_name;

  // Member: current_mode
  rmf_door_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.current_mode);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rmf_door_msgs
get_serialized_size(
  const rmf_door_msgs::msg::DoorState & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: door_time

  current_alignment +=
    builtin_interfaces::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.door_time, current_alignment);
  // Member: door_name
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.door_name.size() + 1);
  // Member: current_mode

  current_alignment +=
    rmf_door_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.current_mode, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rmf_door_msgs
max_serialized_size_DoorState(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: door_time
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        builtin_interfaces::msg::typesupport_fastrtps_cpp::max_serialized_size_Time(
        full_bounded, current_alignment);
    }
  }

  // Member: door_name
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: current_mode
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rmf_door_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_DoorMode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _DoorState__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rmf_door_msgs::msg::DoorState *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _DoorState__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rmf_door_msgs::msg::DoorState *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _DoorState__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rmf_door_msgs::msg::DoorState *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _DoorState__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_DoorState(full_bounded, 0);
}

static message_type_support_callbacks_t _DoorState__callbacks = {
  "rmf_door_msgs::msg",
  "DoorState",
  _DoorState__cdr_serialize,
  _DoorState__cdr_deserialize,
  _DoorState__get_serialized_size,
  _DoorState__max_serialized_size
};

static rosidl_message_type_support_t _DoorState__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_DoorState__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace rmf_door_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rmf_door_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rmf_door_msgs::msg::DoorState>()
{
  return &rmf_door_msgs::msg::typesupport_fastrtps_cpp::_DoorState__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rmf_door_msgs, msg, DoorState)() {
  return &rmf_door_msgs::msg::typesupport_fastrtps_cpp::_DoorState__handle;
}

#ifdef __cplusplus
}
#endif
